/**************************************************************** 
 * Description: 优先队列+前缀和 100分
 * Author: Alex Li
 * Date: 2024-08-04 18:06:43
 * LastEditTime: 2024-08-06 17:50:10
****************************************************************/

//核心算法，不管有几个廊桥，某第i个廊桥能停靠的数量是定值！！！有了这个结论才能用前缀和
#include <iostream>
#include <utility>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

int m[2],n;// m[0] 表示国内航班数，m[1] 表示国际航班数，n 表示廊桥数
// 定义航班结构体
struct plane{
    int l,r;   // l 表示航班到达时间，r 表示航班离开时间
}a[2][100000]; // a[0] 表示国内航班，a[1] 表示国际航班

// ans[0][i] 表示使用 i 个廊桥时可以停靠的国内航班数量，
// ans[1][i] 表示使用 i 个廊桥时可以停靠的国际航班数量.
int ans[2][100001];

// 比较函数，用于按到达时间排序
bool mp(plane a, plane b){
    return a.l<b.l;
}
// 计算每个廊桥数量下可以停靠的航班数
void js(int bh){
    // 小顶堆，按起飞时间排序，存储当前在廊桥上的航班,
    //第一个元素 (pair.first) 表示航班的离开时间，第二个元素 (pair.second) 表示廊桥的编号。
    priority_queue<pair<int,int>,vector<pair<int,int>>,greater<pair<int,int>>> smwy;
    // 小顶堆，存储空闲的廊桥编号
    priority_queue<int,vector<int>,greater<int>> ytemp;
    //// 初始化廊桥堆
    for(int i=1;i<=n;i++) ytemp.push(i);
    // 遍历所有航班,m[0]是国内，m[1]是国外
    for(int i=1;i<=m[bh];i++){ 
        // 将所有已经起飞的航班从廊桥堆中移除，并将廊桥编号放回空闲廊桥堆
        while(!smwy.empty()&&a[bh][i].l>=smwy.top().first){ 
            ytemp.push(smwy.top().second);
            smwy.pop();
        }
        // 如果没有空闲廊桥，则继续
        if(ytemp.empty())continue;
        int tmp=ytemp.top();// 取出一个空闲廊桥
        ans[bh][tmp]++;// 对应廊桥的航班数加1
        smwy.push(make_pair(a[bh][i].r,tmp));// 将当前航班放入廊桥堆，使用pair表示：{离开时间, 廊桥编号}
        ytemp.pop(); // 移除已使用的廊桥
       
    }
    // 计算前缀和，累积每个廊桥数量下的航班数
    for(int i=1;i<=n;i++)ans[bh][i]+=ans[bh][i-1];
}

int main(){
    cin>>n>>m[0]>>m[1];// 读取廊桥数、国内航班数和国际航班数
    // 读取国内航班信息
    for(int i=1;i<=m[0];i++)cin>>a[0][i].l>>a[0][i].r;
    // 读取国际航班信息
    for(int i=1;i<=m[1];i++)cin>>a[1][i].l>>a[1][i].r;
    // 对国内航班按到达时间排序
    sort(&a[0][0],&a[0][m[0]+1],mp); //区间是左闭右开，a[i]从i=1开始，所以+1
    // 对国际航班按到达时间排序
    sort(&a[1][0],&a[1][m[1]+1],mp);

    js(0);// 计算国内航班的前缀和
    js(1);// 计算国际航班的前缀和
    int mx=-1;
    for(int i=0;i<=n;i++)mx=max(mx,ans[0][i]+ans[1][n-i]);
    cout<<mx<<endl;
    return 0;

}


